import { __spread, __decorate, __metadata } from 'tslib';
import { LoadingBarService, LoadingBarModule } from '@ngx-loading-bar/core';
import { Injectable, NgModule } from '@angular/core';
import { HttpClientModule, HTTP_INTERCEPTORS } from '@angular/common/http';
import { finalize } from 'rxjs/operators';

var LoadingBarInterceptor = /** @class */ (function () {
    function LoadingBarInterceptor(loader) {
        this.loader = loader;
        this.state = this.loader.useRef('http');
    }
    LoadingBarInterceptor.prototype.intercept = function (req, next) {
        var _this = this;
        // https://github.com/angular/angular/issues/18155
        if (req.headers.has('ignoreLoadingBar')) {
            return next.handle(req.clone({ headers: req.headers.delete('ignoreLoadingBar') }));
        }
        var r = next.handle(req);
        var started = false;
        var responseSubscribe = r.subscribe.bind(r);
        r.subscribe = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            _this.state.start();
            started = true;
            return responseSubscribe.apply(void 0, __spread(args));
        };
        return r.pipe(finalize(function () { return started && _this.state.complete(); }));
    };
    LoadingBarInterceptor.ctorParameters = function () { return [
        { type: LoadingBarService }
    ]; };
    LoadingBarInterceptor = __decorate([
        Injectable(),
        __metadata("design:paramtypes", [LoadingBarService])
    ], LoadingBarInterceptor);
    return LoadingBarInterceptor;
}());

var LoadingBarHttpClientModule = /** @class */ (function () {
    function LoadingBarHttpClientModule() {
    }
    LoadingBarHttpClientModule = __decorate([
        NgModule({
            imports: [
                HttpClientModule,
                LoadingBarModule,
            ],
            exports: [
                HttpClientModule,
                LoadingBarModule,
            ],
            providers: [
                { provide: HTTP_INTERCEPTORS, useClass: LoadingBarInterceptor, multi: true },
            ],
        })
    ], LoadingBarHttpClientModule);
    return LoadingBarHttpClientModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { LoadingBarHttpClientModule, LoadingBarInterceptor as ɵa };
//# sourceMappingURL=ngx-loading-bar-http-client.js.map
